"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("itee-validators"),t=require("itee-core"),s=require("express"),r=require("http"),i=require("https"),o=require("path");function a(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var n=a(s),c=a(r),l=a(i),p=a(o);
/**
 * @author [Tristan Valcke]{@link https://github.com/Itee}
 * @license [BSD-3-Clause]{@link https://opensource.org/licenses/BSD-3-Clause}
 *
 * @file Todo
 *
 * @example Todo
 *
 */
class h extends t.TAbstractObject{get applications(){return this._applications}set applications(e){this._applications=e}setApplications(e){return this.applications=e,this}addMiddleware(e){return this.applications.use(e),this}get router(){return this._router}set router(e){this._router=e}setRouter(e){return this.router=e,this}get databases(){return this._databases}set databases(e){this._databases=e}setDatabases(e){return this.databases=e,this}addDatabase(e,t){return this._databases.set(e,t),this}get servers(){return this._servers}set servers(e){this._servers=e}setServers(e){return this.servers=e,this}constructor(e={}){super({...e}),this.rootPath=e.rootPath,this.applications=n.default(),this.router=n.default.Router,this.databases=new Map,this.servers=new Map,this.connections=[],this._initApplications(e.applications),this._initDatabases(e.databases),this._initServers(e.servers)}get rootPath(){return this._rootPath}set rootPath(t){if(e.isNull(t))throw new TypeError("Root path cannot be null ! Expect a non empty string.");if(e.isUndefined(t))throw new TypeError("Root path cannot be undefined ! Expect a non empty string.");if(e.isNotString(t))throw new TypeError(`Root path cannot be an instance of ${t.constructor.name} ! Expect a non empty string.`);if(e.isEmptyString(t))throw new TypeError("Root path cannot be empty ! Expect a non empty string.");if(e.isBlankString(t))throw new TypeError("Root path cannot contain only whitespace ! Expect a non empty string.");this._rootPath=t}setRootPath(e){return this.rootPath=e,this}_initApplications(e){e.case_sensitive_routing&&this.applications.set("case sensitive routing",e.case_sensitive_routing),e.env&&this.applications.set("env",e.env),e.etag&&this.applications.set("etag",e.etag),e.jsonp_callback_name&&this.applications.set("jsonp callback name",e.jsonp_callback_name),e.jsonp_escape&&this.applications.set("json escape",e.jsonp_escape),e.jsonp_replacer&&this.applications.set("json replacer",e.jsonp_replacer),e.jsonp_spaces&&this.applications.set("json spaces",e.jsonp_spaces),e.query_parser&&this.applications.set("query parser",e.query_parser),e.strict_routing&&this.applications.set("strict routing",e.strict_routing),e.subdomain_offset&&this.applications.set("subdomain offset",e.subdomain_offset),e.trust_proxy&&this.applications.set("trust proxy",e.trust_proxy),e.views&&this.applications.set("views",e.views),e.view_cache&&this.applications.set("view cache",e.view_cache),e.view_engine&&this.applications.set("view engine",e.view_engine),e.x_powered_by&&this.applications.set("x-powered-by",e.x_powered_by),this._initMiddlewares(e.middlewares),this._initRouters(e.routers)}_initMiddlewares(t){for(let[s,r]of Object.entries(t)){if(e.isNotArray(r))throw new TypeError(`Invalid middlware configuration for ${s}, expecting an array of arguments to spread to middleware module, got ${r.constructor.name}`);this._initPackageMiddleware(s,r)?this.logger.log(`Use ${s} middleware from node_modules`):this._initLocalMiddleware(s,r)?this.logger.log(`Use ${s} middleware from local folder`):this.logger.error(`Unable to register the middleware ${s} the package and/or local file doesn't seem to exist ! Skip it.`)}}_initPackageMiddleware(e,t){let s=!1;try{this.applications.use(require(e)(...t)),s=!0}catch(t){t.code&&"MODULE_NOT_FOUND"===t.code||(this.logger.error(`The middleware "${e}" seems to encounter internal error.`),this.logger.error(t))}return s}_initLocalMiddleware(e,t){let s=!1;try{const r=p.default.join(this.rootPath,"middlewares",e);this.applications.use(require(r)(...t)),s=!0}catch(e){this.logger.error(e)}return s}_initRouters(e){for(let[t,s]of Object.entries(e))this._initPackageRouter(t,s)?this.logger.log(`Use ${s} router from node_modules over base route: ${t}`):this._initLocalRouter(t,s)?this.logger.log(`Use ${s} router from local folder over base route: ${t}`):this.logger.error(`Unable to register the router ${s} the package and/or local file doesn't seem to exist ! Skip it.`)}_initPackageRouter(e,t){let s=!1;try{this.applications.use(e,require(t)),s=!0}catch(e){e.code&&"MODULE_NOT_FOUND"===e.code||(this.logger.error(`The router "${name}" seems to encounter internal error.`),this.logger.error(e))}return s}_initLocalRouter(e,t){let s=!1;try{const r=p.default.join(this.rootPath,"routers",t);this.applications.use(e,require(r)),s=!0}catch(e){e instanceof TypeError&&"Found non-callable @@iterator"===e.message&&this.logger.error(`The router "${name}" seems to encounter error ! Are you using an object instead an array for router configuration ?`),this.logger.error(e)}return s}_initDatabases(t){for(let s=0,r=t.length;s<r;s++){const r=t[s],i=r.type,o=r.from,a=`${r.name?r.name:`${i}_${s}`}`;try{let t=null;if(e.isDefined(o)){t=new(require(o)[i])({application:this.applications,router:this.router,...r})}t.connect(),this.databases.set(a,t)}catch(e){this.logger.error(`Unable to create database of type ${i} due to ${e.name}`),this.logger.error(e.message),this.logger.error(e.stack)}}}_initServers(t){const s=e.isArray(t)?t:[t];for(let e=0,t=s.length;e<t;e++){let t=s[e],r=null;if("https"===t.type){const e={pfx:t.pfx,passphrase:t.passphrase};r=l.default.createServer(e,this.applications)}else r=c.default.createServer(this.applications);r.name=t.name||`${t.name?t.name:`Server_${e}`}`,r.maxHeadersCount=t.max_headers_count,r.timeout=t.timeout,r.type=t.type,r.host=t.host,r.port=t.port,r.env=t.env,r.listen(t.port,t.host,(()=>{this.logger.log(`${r.name} start listening on ${r.type}://${r.host}:${r.port} at ${new Date} under ${r.env} environment.`)})),r.on("connection",(e=>{this.connections.push(e),e.on("close",(()=>{this.connections=this.connections.filter((t=>t!==e))}))})),this.servers.set(r.name,r)}}databaseOn(e,t,s){}serverOn(e,t,s){this.servers[e].on(t,s)}serversOn(e,t,s){for(let e in this.servers)this.serverOn(e,t,s)}start(){}stop(e){const t=this.servers.size,s=this.databases.size;let r=0,i=0;if(!o()){for(const[e,t]of this.databases)t.close((()=>{i++,this.logger.log(`Connection to ${e} is closed.`),o()}));for(let e of this.connections)e.end();for(const[e,t]of this.servers)t.close((()=>{r++,this.logger.log(`The ${e} listening on ${t.type}://${t.host}:${t.port} is shutted down.`),o()}))}function o(){return!(r<t)&&(!(i<s)&&void(e&&e()))}}closeServers(){}}exports.TBackendManager=h;
